/*******************************************************************************
 *
 * File Name: ANNTraining.h
 * Author: Richard Baxter
 * Project: Advanced Neural Network (ANN)
 * Project Version: 2a4d 24-Oct-09
 * Comments:
 *
 *******************************************************************************/

#ifndef HEADER_ANN_TRAINING
#define HEADER_ANN_TRAINING

#include "ANNneuronClass.h"
#include "ANNexperienceClass.h"
#include "SHAREDglobalDefs.h"

#define	MAX_NUM_FOLDS_ANNTH 10
#define IRRELEVANT 0.0
#define	ACCEPTABLE_ERROR_RATE 0.01F
//#define	ACCEPTABLE_ERROR_RATE 0.005F
	//99.5% accuracy is defined as the acceptable error rate. no more epochs will be calculated once this is reached.

#define	ANN_DEFAULT_MAX_NUMBER_OF_EPOCHS 500
#define	ANN_DEFAULT_SIMPLE_TRAIN_DEFAULT_NUM_OF_TRAINING_EPOCHS 320


#define ERROR_VARIATION_ALLOWED 0.002F
//#define ERROR_VARIATION_ALLOWED 0.01F	//1%

#define REAL_LIFE_ACCURACY_DIAGNOSTICS_CUTOFF 0.1





double calculateExperienceErrorForHypotheticalDecision(NeuronContainer * firstInputNeuronInNetwork, NeuronContainer * firstOutputNeuronInNetwork, long numberOfInputNeurons, long numberOfOutputNeurons, Experience * experience);

void feedNeuralNetworkWithASetOfExperiences(NeuronContainer * firstInputNeuron, NeuronContainer * firstOutputNeuron, int numberOfInputNeurons, int numberOfOutputNeurons, Experience * firstExperienceInList);

void trainNeuralNetworkSimple(NeuronContainer * firstInputNeuron, NeuronContainer * firstOutputNeuron, int numberOfInputNeurons, int numberOfOutputNeurons, int numEpochs, Experience * firstExperienceInDataSet, long numberOfExperiences);
void trainNeuralNetwork(NeuronContainer * firstInputNeuron, NeuronContainer * firstOutputNeuron, int numberOfInputNeurons, int numberOfOutputNeurons, int maxFolds, Experience * firstExperienceInDataSet, long numberOfExperiences, int maxEpochs);

	void storeNeuralNetworkBiasAndWeights(NeuronContainer * neuronBeingAccessed);
	void restoreNeuralNetworkWithStoredBiasAndWeights(NeuronContainer * neuronBeingAccessed);
	void resetNeuralNetworkWithRandomBiasAndWeights(NeuronContainer * neuronBeingAccessed);
	void resetInputsAndClassTargets(NeuronContainer * firstInputNeuron, NeuronContainer * firstOutputNeuron, long numberOfInputNeurons, long numberOfOutputNeurons, Experience * currentExperienceInDataSet);
	float calculateStandardDeviation(float* array, int length, float average);


#endif
