/*******************************************************************************
 *
 * File Name: ANNUpdateAlgorithm.h
 * Author: Richard Baxter
 * Project: Advanced Neural Network (ANN)
 * Project Version: 2a4d 24-Oct-09
 * Comments:
 *
 *******************************************************************************/

#ifndef HEADER_ANN_UPDATE_ALGORITHM
#define HEADER_ANN_UPDATE_ALGORITHM

#include "ANNneuronClass.h"

double ANNBackPropogationPass(NeuronContainer * firstInputNeuronInNetwork, NeuronContainer * firstOutputNeuronInNetwork);
	void forwardPassStep(NeuronContainer * neuronBeingAccessed);
		void adjustOutputValueOfANeuronBasedOnBackNeurons(NeuronContainer * neuronBeingAccessed);
	void backwardPassStep(NeuronContainer * neuronBeingAccessed, int isOutputLayer, bool isSubnet);
		void calculateOutputErrorOfOutputNeuron(NeuronContainer * neuronBeingAccessed);
		void calculateOutputErrorOfNonoutputNeuron(NeuronContainer * neuronBeingAccessed);
		void calculateNewBackConnectionWeightsOfNeuron(NeuronContainer * neuronBeingAccessed);
		void calculateNewBiasOfNeuron(NeuronContainer * neuronBeingAccessed);
	double calculateErrorOfBackPropPass(NeuronContainer * firstOutputNeuronInNetwork);
	
	void calculateErrorOfOutputNeurons(NeuronContainer * firstOutputNeuronInNetwork);







#ifdef ANN

void copyNeuronContainerListToNeuronConnectionContainerList(NeuronConnectionContainer * firstNeuronConnectionInListToUpdate, NeuronContainer * firstNeuronInListToCopy);
void copyNeuronConnectionContainerListToNeuronContainerList(NeuronContainer * firstNeuronInListToUpdate, NeuronConnectionContainer * firstNeuronConnectionInListToCopy);

//void copyNeuronListIntoNeuronReferenceArray(NeuronContainer * neuronReferenceArrayToUpdate[], NeuronContainer * firstNeuronInListToCopy);
//void copyNeuronReferenceArrayIntoNeuronList(NeuronContainer * firstNeuronInListToUpdate, NeuronContainer * neuronReferenceArrayToCopy[]);

#endif

float calculateOValue(float netValue);


void DEBUGsetDataSetNum(int newdataSetNum);


#endif

