/*******************************************************************************
 *
 * File Name: SHAREDvars.h
 * Author: Richard Baxter
 * Project: Generic Construct Functions
 * Project Version: 2a4d 24-Oct-09
 *
 *******************************************************************************/
 
#ifndef HEADER_SHARED_VARS
#define HEADER_SHARED_VARS

#define MAX_RGB_VAL (255)
#define MAX_LUMINOSITY (MAX_RGB_VAL*RGB_NUM)
#define MAX_LUMINOSITY_CONTRAST (MAX_LUMINOSITY)
#define MAX_NORMAL (1.0)
#define MAX_NORMAL_CONTRAST (MAX_NORMAL)
#define EDGE_LUMINOSITY_CONTRAST_THRESHOLD ((20.0/254.0)*MAX_LUMINOSITY_CONTRAST)
#define EDGE_NORMAL_CONTRAST_THRESHOLD (0.1*MAX_NORMAL_CONTRAST)

#define TRUE (1)
#define FALSE (0)

#define REALLY_FAR_AWAY (99999999999.9)
#define REALLY_LARGE_DOUBLE (1000000.0)
#define REALLY_SMALL_DOUBLE (-1000000.0)

#define OR_METHOD2DOD_DIMENSIONS (2)
#define OR_METHOD3DOD_DIMENSIONS (3)

/* common definitions */
typedef struct { unsigned char r, g, b; } colour;
typedef struct { double x, y, z; } vec;
typedef struct { vec a; vec b; vec c; } mat;

#ifdef COMPILE_OLC
	#define DOUBLE_MIN_PRECISION 0.005
#else
	#define DOUBLE_MIN_PRECISION 0.00001
#endif


bool compareDoubles(double a, double b);
bool compareDoublesArbitraryError(double a, double b, double error);

int maxInt(int a, int b);	//should be turned into a macro instead
int minInt(int a, int b);	//should be turned into a macro instead

double minDouble(double a, double b);	//should be turned into a macro instead
double maxDouble(double a, double b);	//should be turned into a macro instead

double absDouble(double val);

int exists_argument(int argc,char **argv,char *keystr);
float get_float_argument(int argc,char **argv,char *keystr);
char *get_char_argument(int argc,char **argv,char *keystr);

void copyColours(colour * colToModify, colour * colToCopy);

#endif
